var extpay = ExtPay('canvashack');

// In content.js
chrome.storage.local.get(['paid', 'lifetimePaid', 'blockedUrls'], function(result) {
    const currentUrl = new URL(window.location.href).href;

    // Function to normalize and compare URLs, ignoring 'www.' and subpage paths
    function normalizeUrl(url) {
        if (!url || typeof url !== 'string') return ''; // Return empty string if invalid
        try {
            let parsedUrl = new URL(url);
            let hostname = parsedUrl.hostname.replace(/^www\./, '');
            return `${parsedUrl.protocol}//${hostname}`;
        } catch (e) {
            console.error('Invalid URL:', url); // Log invalid URLs for debugging
            return ''; // Return empty string if URL is invalid
        }
    }

    const isBlocked = result.blockedUrls && result.blockedUrls.some(blockedUrl => {
        if (!blockedUrl.trim()) return false; // Skip empty URLs
        const normalizedBlockedUrl = normalizeUrl(blockedUrl.trim());
        const normalizedCurrentUrl = normalizeUrl(currentUrl);
        return normalizedCurrentUrl.startsWith(normalizedBlockedUrl);
    });

    if (isBlocked) {
        console.log(`[Canvas Hack] Injection blocked on: ${currentUrl}`);
        return; // Exit the script if the URL is blocked
    }

    // Force set to true so everyone gets the paid features
    const isPaid = true; // Assume paid for now

    function checkMetaTag() {
        const metaElement = document.querySelector('meta[name="apple-itunes-app"][content="app-id=480883488"]');
        
        if (metaElement && !isPaid) {
            // If user hasn't purchased, open the popup
            chrome.runtime.sendMessage({ action: 'openPurchasePopup' });
        }
    }

    checkMetaTag();

    if (isPaid) {
        chrome.storage.local.set({ injectQuizAnswers: true }, function() {
            console.log('injectQuizAnswers set to true in storage.');
        });

        console.log("This site has NOT been blocked from CanvasHacks injecting service and is fully running its protection scripts.");

        chrome.storage.local.get(['shouldReload'], function(result) {
            const barExists = document.getElementById('input') !== null;
            const iframeExists = document.getElementById('kioskIframe') !== null;

            if (barExists && iframeExists) {
                if (result.shouldReload) {
                    // Reload tab if necessary
                    chrome.storage.local.set({ shouldReload: false });
                } else {
                    // Set shouldReload to true and reload the tab
                    chrome.storage.local.set({ shouldReload: true }, function() {
                        chrome.runtime.sendMessage({ action: "reloadTab" });
                    });
                }
            }
        });

        // Inject and manage canvas HTML bar
        let barInjected = false;
        chrome.runtime.onMessage.addListener(function(request) {
            if (request.action === "toggleBar") {
                if (!barInjected) {
                    injectBar();
                    barInjected = true;
                } else {
                    toggleBarVisibility();
                }
            }
        });

        // Function to inject bar into the page
        function injectBar() {
            const pageSrc = window.location.href;
            const barHtml = `
            <div id="input">
                <!-- SVG Icons and other HTML Content here -->
                <p>Restart session</p>
                <iframe src="${pageSrc}" id="kioskIframe" scrolling="auto" sandbox="allow-same-origin allow-scripts allow-forms allow-top-navigation allow-top-navigation-by-user-activation"></iframe>
                <style>
                    body {
                        height: 100vh;
                        width: 100vw;
                        margin: 0;
                        padding: 0;
                        overflow: hidden;
                    }

                    .bar {
                        position: fixed;
                        height: 2.75vw;
                        top: 0;
                        left: 0;
                        width: 100vw;
                        background-color: #e4e4e4;
                        border-bottom: 1px solid #b6b6b6;
                        display: flex;
                        margin: auto;
                        align-items: center;
                        padding-left: .8vw;
                        gap: 1.1vw;
                        user-select: none;
                        z-index: 9999999999999;
                    }

                    iframe {
                        position: fixed;
                        border: none;
                        top: 2.75vw;
                        width: 100vw;
                        height: 100vh;
                        left: 0;
                        z-index: 99999;
                    }
                    
                    .bar p {
                        font-size: 1vw;
                        margin: 0;
                        font-family: 'Roboto', sans-serif;
                        font-weight: 400;
                        margin-left: .2vw;
                    }

                    .home {
                        height: 1vw;
                        width: .8vw;
                    }

                    .reload {
                        height: 1vw;
                        width: 1.1vw;
                    }
                </style>
            </div>
            `;
            const div = document.createElement('div');
            div.innerHTML = barHtml;
            document.body.insertBefore(div, document.body.firstChild);

            // Injecting external style
            const link = document.createElement('link');
            link.href = chrome.runtime.getURL('style.css');
            link.rel = 'stylesheet';
            document.head.appendChild(link);
        }

        // Function to toggle bar visibility
        function toggleBarVisibility() {
            const bar = document.querySelector('#input');
            if (bar) {
                bar.style.display = bar.style.display === 'none' ? 'block' : 'none';
            }
        }
    } else {
        console.log("User has not paid, scripts will not be injected.");

        chrome.storage.local.set({ injectQuizAnswers: false }, function() {
            console.log('injectQuizAnswers set to false in storage.');
        });
    }
});
